//Pulso de reloj analógico mediante interrupciones internas
/*
 'seta43
'xstaseta@gmail.com
'http: / / seta43.duckdns.org
'http: / / seta43.blogspot.com /
*/
//08/02/2022

#include <avr/io.h>
#include <avr/interrupt.h>

#define RTIME 31

byte LedPin=13;
#define PULSADOR 6


byte horas,minutos,segundos,segu10,minu10;
byte bandera=1;
int repeticion=100;



void setup(){
  Serial.begin(9600);

  pinMode(LedPin, OUTPUT);
  pinMode(2, OUTPUT); //Segundos
  pinMode(3, OUTPUT);
  pinMode(4, OUTPUT); //Minutos
  pinMode(5, OUTPUT);
  //pinMode(PULSADOR, INPUT);
  //Setup buttons with internal pullup 
  pinMode(PULSADOR,INPUT_PULLUP);
  digitalWrite(PULSADOR,HIGH);

  Serial.println("RelojAnalogico");
  
  cli();
  TCCR1A=0;
  TCCR1B=0;
  OCR1A=15624;
  TCCR1B |= (1<<WGM12);   //  0 1 0 0 CTC OCR1A Immediate MAX
  TCCR1B |= (1<<CS10);    // clk I/O /1024 (From prescaler)
  TCCR1B |= (1<<CS12);
  TIMSK1=(1<<OCIE1A);     // Timer/Counter1, Output Compare A Match Interrupt Enable
  sei();


  ADCSRA = ADCSRA & B01111111;  // Disable A/D
  ACSR = B10000000;
  
}

void loop()
{
  delay(1);
  if(bandera)
    {
     bandera=0;
     digitalWrite(LedPin, !digitalRead(LedPin)); 
     increS();
     Serial.print(minutos); Serial.print(":");  Serial.println(segundos);  
    }  

  if(digitalRead(PULSADOR)==0)
    {
      incre10M();
      Serial.println("INC_Minutos");
      delay(repeticion);
      repeticion-=10;
      if(repeticion<10) repeticion=10;
    }

}


void increS(void)
{
  repeticion+=20;
  if(repeticion>100) repeticion=100;
  
  segu10++;
  if(segu10>9)
    {
      segu10=0;
      incre10M();
    }
  if(segundos & 1)
    {
      digitalWrite(2, 0);
      digitalWrite(3, 1);
      delay(RTIME);
      digitalWrite(3, 0);
    }
    else
    {
      digitalWrite(3, 0);
      digitalWrite(2, 1);
      delay(RTIME);
      digitalWrite(2, 0);
    }
}


void incre10M(void)
{
  minu10++;
  if(minu10 & 1)
    {
      digitalWrite(4, 0);
      digitalWrite(5, 1);
      delay(RTIME);
      digitalWrite(5, 0);
      Serial.print("x ");
    }
    else
    {
      digitalWrite(5, 0);
      digitalWrite(4, 1);
      delay(RTIME);
      digitalWrite(4, 0);
      Serial.print("* ");
    }
}


 


ISR(TIMER1_COMPA_vect)
{
  bandera=1;
  segundos++;
  if(segundos>59)
    {
     segundos=0;
     minutos++;
     if(minutos>59)
         {
          minutos=0;
          horas++;
            if(horas>23)
              {               
               segundos=0;
               minutos=0;
               horas=0;
              }
         } 
    }
     
}
